﻿// Copyright (c) Microsoft Corporation.  All rights reserved.

//------------------------------------------------------------------------------
// PLEASE NOTE:  Microsoft Corporation (or based on where you live, one of its affiliates) 
// licenses this supplement to you.  You may use it with each validly licensed copy of Microsoft 
// Visual Studio Pre-Release Code-Name "ORCAS" software (the “software”).  You may not use the 
// supplement if you do not have a license for the software.  The license terms for the software 
// apply to your use of this supplement. 
//
// Please note: As this software is distributed in Quebec, Canada, this notice is provided below in French.
// Remarque: Ce logiciel étant distribué au Québec, Canada, les termes de cette licence sont fournis ci-dessous en français.
// REMARQUE:  Microsoft Corporation (ou en fonction du lieu où vous vivez, l’un de ses affiliés) vous 
// accorde une licence pour ce supplément.  Vous pouvez utiliser une copie de ce supplément avec chaque 
// copie concédée sous licence du logiciel Microsoft Visual Studio Pre-Release Code-Name "ORCAS" (le « logiciel »).  
// Vous n’êtes pas autorisé à utiliser ce supplément si vous n’êtes pas titulaire d’une licence pour le logiciel.  
// Les conditions de licence pour le logiciel s’appliquent à l’utilisation de ce supplément.  
//------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace RichClient
{
    /// <summary>
    /// we are using a custom binding source implementation 
    /// for this application because we have not mapped the entire 
    /// Nortwhind DB and deleting products (or categories that cascade to products)
    /// could cause referential integrity violations with existing order_details rows.
    /// 
    /// This implementation mereely sets the AllowRemove property
    /// to false whereas the readonly property of the base class
    /// is true.
    /// </summary>
    class EntityBindingSource : BindingSource
    {
        public EntityBindingSource(System.ComponentModel.IContainer container)
            : base(container){}


        public override bool AllowRemove
        {
            get
            {
                return false;
            }
        }

    }
}
