// Copyright (c) Microsoft Corporation.  All rights reserved.

//------------------------------------------------------------------------------
// PLEASE NOTE:  Microsoft Corporation (or based on where you live, one of its affiliates) 
// licenses this supplement to you.  You may use it with each validly licensed copy of Microsoft 
// Visual Studio Pre-Release Code-Name "ORCAS" software (the “software”).  You may not use the 
// supplement if you do not have a license for the software.  The license terms for the software 
// apply to your use of this supplement. 
//
// Please note: As this software is distributed in Quebec, Canada, this notice is provided below in French.
// Remarque: Ce logiciel étant distribué au Québec, Canada, les termes de cette licence sont fournis ci-dessous en français.
// REMARQUE:  Microsoft Corporation (ou en fonction du lieu où vous vivez, l’un de ses affiliés) vous 
// accorde une licence pour ce supplément.  Vous pouvez utiliser une copie de ce supplément avec chaque 
// copie concédée sous licence du logiciel Microsoft Visual Studio Pre-Release Code-Name "ORCAS" (le « logiciel »).  
// Vous n’êtes pas autorisé à utiliser ce supplément si vous n’êtes pas titulaire d’une licence pour le logiciel.  
// Les conditions de licence pour le logiciel s’appliquent à l’utilisation de ce supplément.  
//------------------------------------------------------------------------------
using System;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Configuration;
using System.Data.Common;
using System.Data.Mapping;
using System.Data.Metadata;
using System.Data.Objects;
using NorthwindLib;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Products : System.Web.Services.WebService
{
    // Return all product categories
    [WebMethod]
    public string[] GetCategories() {
        using(Northwind db = new Northwind((string)Application["ConnectionString"])) {

            ObjectQuery<string> cats = db.CreateQuery<string>(
                "SELECT VALUE c.CategoryName FROM Categories AS c ORDER BY c.CategoryName");

            return new List<string>(cats).ToArray();
        }
    }

    // Return active (non-discontinued products) for a given category
    [WebMethod]
    public Product[] GetProductsByCategory(string categoryName) {
        using(Northwind db = new Northwind((string)Application["ConnectionString"])) {
            ObjectQuery<Product> products = db.CreateQuery<Product>(
                "Select value p from Products as p where p.Category.CategoryName == @categoryName and p is of (NorthwindLib.Product) order by p.ProductName", new ObjectParameter("categoryName", categoryName));
            return new List<Product>(products).ToArray();            
        }
    }


    // Return all the discontinued products
    [WebMethod]
    public DiscontinuedProduct[] GetDiscontinuedProducts() {
        using(Northwind db = new Northwind((string)Application["ConnectionString"])) {
            return new List<DiscontinuedProduct>(db.Products.OfType<DiscontinuedProduct>()).ToArray();
        }
    }




}

