' Copyright (c) Microsoft Corporation.  All rights reserved.

'------------------------------------------------------------------------------
' PLEASE NOTE:  Microsoft Corporation (or based on where you live, one of its affiliates) 
' licenses this supplement to you.  You may use it with each validly licensed copy of Microsoft 
' Visual Studio Pre-Release Code-Name "ORCAS" software (the “software”).  You may not use the 
' supplement if you do not have a license for the software.  The license terms for the software 
' apply to your use of this supplement. 
'
' Please note: As this software is distributed in Quebec, Canada, this notice is provided below in French.
' Remarque: Ce logiciel étant distribué au Québec, Canada, les termes de cette licence sont fournis ci-dessous en français.
' REMARQUE:  Microsoft Corporation (ou en fonction du lieu où vous vivez, l’un de ses affiliés) vous 
' accorde une licence pour ce supplément.  Vous pouvez utiliser une copie de ce supplément avec chaque 
' copie concédée sous licence du logiciel Microsoft Visual Studio Pre-Release Code-Name "ORCAS" (le « logiciel »).  
' Vous n’êtes pas autorisé à utiliser ce supplément si vous n’êtes pas titulaire d’une licence pour le logiciel.  
' Les conditions de licence pour le logiciel s’appliquent à l’utilisation de ce supplément.  
'------------------------------------------------------------------------------
Imports System.Web
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.ComponentModel
Imports System.Data.Objects
Imports System.Collections.Generic

Imports NorthwindLib


<WebService(Namespace:="http://tempuri.org/")> _
<WebServiceBinding(ConformsTo:=WsiProfiles.BasicProfile1_1)> _
<Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
Public Class WSProducts
     Inherits System.Web.Services.WebService

    ' Return all product categories
    <WebMethod()> _
    Public Function GetCategories() As String()
        Using db As New Northwind(CType(Application("ConnectionString"), String))

            Dim categories As ObjectQuery(Of String) = db.CreateQuery(Of String)("SELECT VALUE c.CategoryName FROM Categories AS c ORDER BY c.CategoryName")
            Return New List(Of String)(categories).ToArray()

        End Using
    End Function

    ' Return active (non-discontinued products) for a given category
    <WebMethod()> _
    Public Function GetProductsByCategory(ByVal categoryName As String) As Product()
        Using db As New Northwind(CType(Application("ConnectionString"), String))

            Dim products As ObjectQuery(Of Product) = db.CreateQuery(Of Product)("Select value p from Products as p where p.Category.CategoryName == @categoryName and p is of (NorthwindLib.Product) order by p.ProductName", New ObjectParameter("categoryName", categoryName))
            Return New List(Of Product)(products).ToArray()

        End Using
    End Function

    ' Return all the discontinued products
    <WebMethod()> _
    Public Function GetDiscontinuedProducts() As DiscontinuedProduct()
        Using db As New Northwind(CType(Application("ConnectionString"), String))

            Return New List(Of DiscontinuedProduct)(db.Products.OfType(Of DiscontinuedProduct)()).ToArray()

        End Using
    End Function
End Class
