' Copyright (c) Microsoft Corporation.  All rights reserved.

'------------------------------------------------------------------------------
' PLEASE NOTE:  Microsoft Corporation (or based on where you live, one of its affiliates) 
' licenses this supplement to you.  You may use it with each validly licensed copy of Microsoft 
' Visual Studio Pre-Release Code-Name "ORCAS" software (the “software”).  You may not use the 
' supplement if you do not have a license for the software.  The license terms for the software 
' apply to your use of this supplement. 
'
' Please note: As this software is distributed in Quebec, Canada, this notice is provided below in French.
' Remarque: Ce logiciel étant distribué au Québec, Canada, les termes de cette licence sont fournis ci-dessous en français.
' REMARQUE:  Microsoft Corporation (ou en fonction du lieu où vous vivez, l’un de ses affiliés) vous 
' accorde une licence pour ce supplément.  Vous pouvez utiliser une copie de ce supplément avec chaque 
' copie concédée sous licence du logiciel Microsoft Visual Studio Pre-Release Code-Name "ORCAS" (le « logiciel »).  
' Vous n’êtes pas autorisé à utiliser ce supplément si vous n’êtes pas titulaire d’une licence pour le logiciel.  
' Les conditions de licence pour le logiciel s’appliquent à l’utilisation de ce supplément.  
'------------------------------------------------------------------------------
Imports System.Data.Objects
Imports NorthwindLib


Partial Public Class ProductCategories
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not IsPostBack Then
            ' when initially loading the page, get the list of categories
            ' from the database
            Using db As New Northwind(CType(Application("ConnectionString"), String))
                LoadCategoriesGrid(db)
            End Using

        End If

    End Sub

    Sub LoadCategoriesGrid(ByVal db As Northwind)

        ' fetch the list of categories sorted by their names, and get only what we 
        ' need (name, description and key) 
        Dim categories As ObjectQuery(Of Category) = db.CreateQuery(Of Category)("Select value c from Categories as c order by c.CategoryName")

        ' bind the results directly to the grid
        gridCategories.DataSource = categories
        gridCategories.DataBind()
    End Sub

    Protected Sub btnCreateCategory_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCreateCategory.Click
        Using db As New Northwind(CType(Application("ConnectionString"), String))
            Dim cat As New Category()
            cat.CategoryName = txtName.Text
            cat.Description = txtDescription.Text

            ' add the category to the context and push the changes to the database
            db.AddObject(cat)
            db.SaveChanges()

            ' clear the text boxes
            txtName.Text = ""
            txtDescription.Text = ""

            ' reload the contents of the grid
            LoadCategoriesGrid(db)
        End Using
    End Sub
End Class
